<?php
$themename = "BlogDesignStudio Extend";
$shortname = "db";

$alt_stylesheet_path = TEMPLATEPATH . '/styles/';
$alt_stylesheets = array();

if ( is_dir($alt_stylesheet_path) ) {
	if ($alt_stylesheet_dir = opendir($alt_stylesheet_path) ) { 
		while ( ($alt_stylesheet_file = readdir($alt_stylesheet_dir)) !== false ) {
			if(stristr($alt_stylesheet_file, ".css") !== false) {
				$alt_stylesheets[] = $alt_stylesheet_file;
			}
		}	
	}
}

$alt_stylesheets_tmp = asort($alt_stylesheets);
$alt_stylesheets_tmp = array_unshift($alt_stylesheets, "Default");

$alt_sidebar_path = TEMPLATEPATH . '/layouts/';
$alt_sidebars = array();

if ( is_dir($alt_sidebar_path) ) {
	if ($alt_sidebar_dir = opendir($alt_sidebar_path) ) { 
		while ( ($alt_sidebar_file = readdir($alt_sidebar_dir)) !== false ) {
			if(stristr($alt_sidebar_file, ".css") !== false) {
				$alt_sidebars[] = $alt_sidebar_file;
			}
		}	
	}
}

$alt_sidebars_tmp = asort($alt_sidebars);
$alt_sidebars_tmp = array_unshift($alt_sidebars, "Default");


$options = array (

	array(	"name" => "Theme Layout",
		"header" => "Select between one or two sidebars",
		"id" => $shortname."_alt_sidebar",
		"std" => "Select a layout:",
		"type" => "select",
		"options" => $alt_sidebars),

	array(	"name" => "Theme Stylesheet",
		"header" => "Select your colour scheme",
		"id" => $shortname."_alt_stylesheet",
		"std" => "Select a stylesheet:",
		"type" => "select",
		"options" => $alt_stylesheets),
	
	array(	"name" => "Feedburner Address",
		"header" => "Enter Your Feedburner Information",
		"id" => $shortname."_feedburner_address",
		"std" => "",
		"type" => "text"),


);

if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Right Sidebar',
        'before_widget' => '<li id="%1$s" class="widget %2$s">',
        'after_widget' => '</li>',
        'before_title' => '<h2>',
        'after_title' => '</h2>',
    ));
	register_sidebar(array(
		'name' => 'Left Sidebar',
        'before_widget' => '<li id="%1$s" class="widget %2$s">',
        'after_widget' => '</li>',
        'before_title' => '<h2>',
        'after_title' => '</h2>',
    ));



function wp_pagenavi($before = '', $after = '', $prelabel = '', $nxtlabel = '', $pages_to_show = 5, $always_show = false) {
	global $request, $posts_per_page, $wpdb, $paged;
	if(empty($prelabel)) {
		$prelabel  = '<strong>&laquo;</strong>';
	}
	if(empty($nxtlabel)) {
		$nxtlabel = '<strong>&raquo;</strong>';
	}
	$half_pages_to_show = round($pages_to_show/2);
	if (!is_single()) {
		if(!is_category()) {
			preg_match('#FROM\s(.*)\sORDER BY#siU', $request, $matches);		
		} else {
			preg_match('#FROM\s(.*)\sGROUP BY#siU', $request, $matches);		
		}
		$fromwhere = $matches[1];
		$numposts = $wpdb->get_var("SELECT COUNT(DISTINCT ID) FROM $fromwhere");
		$max_page = ceil($numposts /$posts_per_page);
		if(empty($paged)) {
			$paged = 1;
		}
		if($max_page > 1 || $always_show) {
			echo "$before <div class='Nav'><span>Page $paged of $max_page</span>";
			if ($paged >= ($pages_to_show-1)) {
				echo '<a href="'.get_pagenum_link().'">1st</a> <div class="dotts">...</div> ';
			}
			previous_posts_link($prelabel);
			for($i = $paged - $half_pages_to_show; $i  <= $paged + $half_pages_to_show; $i++) {
				if ($i >= 1 && $i <= $max_page) {
					if($i == $paged) {
						echo "<strong class='on'>$i</strong>";
					} else {
						echo ' <a href="'.get_pagenum_link($i).'">'.$i.'</a> ';
					}
				}
			}
			next_posts_link($nxtlabel, $max_page);
			if (($paged+$half_pages_to_show) < ($max_page)) {
				echo ' <div class="dotts">...</div> <a href="'.get_pagenum_link($max_page).'" class="lastpage">Last</a>';
			}
			echo "<div class='NavEnd'></div></div> $after";

		}
	}
}



function mytheme_add_admin() {

	global $themename, $shortname, $options;

	if ( $_GET['page'] == basename(__FILE__) ) {
	
		if ( 'save' == $_REQUEST['action'] ) {

				foreach ($options as $value) {
					update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
					update_option( 'db_layouttype', strip_tags( stripslashes( $_REQUEST['db_layouttype'] ) ) );
					update_option( 'db_layouttype', strip_tags( stripslashes( $_REQUEST['db_layouttype'] ) ) );

				foreach ($options as $value) {
					if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

				header("Location: themes.php?page=functions.php&saved=true");
				die;

		} else if( 'reset' == $_REQUEST['action'] ) {

			foreach ($options as $value) {
				delete_option( $value['id'] ); }
				delete_option('db_layouttype');

			header("Location: themes.php?page=functions.php&reset=true");
			die;

		}
	}

    add_theme_page($themename." Options", "BlogDesignStudio Extend Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}


function db_init() {		

}
function db_add_theme_page() {
	
	if ($_GET['page'] == basename(__FILE__)) {
		if ( 'save' == $_REQUEST['action'] ) {

 
 
}  }}



function mytheme_wp_head() { 
	$stylesheet = get_option('db_alt_stylesheet');
	if($stylesheet != ''){?>
		<link href="<?php bloginfo('template_directory'); ?>/styles/<?php echo $stylesheet; ?>" rel="stylesheet" type="text/css" />
<?php };

	$stylesheet = get_option('db_alt_sidebar');
	if($stylesheet != ''){?>
		<link href="<?php bloginfo('template_directory'); ?>/layouts/<?php echo $stylesheet; ?>" rel="stylesheet" type="text/css" />
<?php };


}

function mytheme_admin() {

	global $themename, $shortname, $options;

	if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
	if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
	
?>
<div class="wrap">
<h2><?php echo $themename; ?> settings</h2>

<form method="post">

<table class="optiontable">

<?php foreach ($options as $value) { 
	
if ($value['type'] == "text") { //If we have configured this for text options ... ?>
		
	<?php if ($value['header'] != "") { ?>
	



	
	<tr scope="row">
		<td></td><td><h3><?php echo $value['header']; ?></h3></td>
	</tr><?php } ?>
	<tr>
		<th style="vertical-align: middle; text-align: left;" scope="row"><?php echo $value['name']; ?>:</th>
		<td>
			<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" />
		</td>
	</tr>

<?php } elseif ($value['type'] == "select") { //If we have configured this for select box options ... ?>

	<?php if ($value['header'] != "") { ?><tr scope="row">
		<td></td><td><h3><?php echo $value['header']; ?></h3></td>
	</tr><?php } ?>
	<tr>
		<th style="vertical-align: middle; text-align: left;" scope="row"><?php echo $value['name']; ?>:</th>
		<td>
			<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
				<?php foreach ($value['options'] as $option) { ?>
				<option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
				<?php } ?>
			</select>
		</td>
	</tr>

<?php } elseif ($value['type'] == "cat_select") { // If You need a category listing for any reason ... ?>
<?php $categories = get_categories(); ?>

	<?php if ($value['header'] != "") { ?><tr scope="row">
		<td></td><td><h3><?php echo $value['header']; ?></h3></td>
	</tr><?php } ?>
	<tr>
		<th style="vertical-align: middle; text-align: left;" scope="row"><?php echo $value['name']; ?>:</th>
		<td>
			<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
			<?php foreach ($categories as $cat) {
			if ( get_settings( $value['id'] ) == $cat->cat_ID) { $selected = ' selected="selected"'; } else { $selected = ''; }
			$opt = '<option value="' . $cat->cat_ID . '"' . $selected . '>' . $cat->cat_name . '</option>';
			echo $opt; } ?>
			</select>
		</td>
	</tr>

<?php
}
}
?>

</table>

<p class="submit">
<input name="save" type="submit" value="Save changes" />	
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>


<p><strong>Usage Agreement</strong></p>
<p>This theme is free for download and use. Leaving the credits in the footer would be appreciated. Enjoy the theme!<br />
If you have any question regarding this theme please <a href="mailto:hello@studiowordpress.com">Contact us</a>.</p>

<p><a href="http://www.studiowordpress.com" target="_blank"><img src="http://www.studiowordpress.com/wp-content/themes/StudioWordpress/images/logo_sign.gif" alt="StudioWordpress"></a></p>

<p><small>Theme tested and rocking steady on Mozilla Firefox, IE7, Safari and Opera.</small></p>


<?php
}
add_action('wp_head', 'mytheme_wp_head');
add_action('admin_menu', 'mytheme_add_admin'); 
?>